【算法|动态规划No.8】leetcode面试题 17.16. 按摩师

个人主页:兜里有颗棉花糖

欢迎 点赞👍 收藏✨ 留言✉ 加关注💓本文由 兜里有颗棉花糖 原创

收录于专栏【手撕算法系列专栏】【LeetCode】

🍔本专栏旨在提高自己算法能力的同时,记录一下自己的学习过程,希望对大家有所帮助

🍓希望我们一起努力、成长,共同进步。

点击直接跳转到该题目

目录

1️⃣题目描述

一个有名的按摩师会收到源源不断的预约请求,每个预约都可以选择接或不接。在每次预约服务之间要有休息时间,因此她不能接受相邻的预约。给定一个预约请求序列,替按摩师找到最优的预约集合(总预约时间最长),返回总的分钟数。

示例1:

输入: 1,2,3,1

输出: 4

解释: 选择 1 号预约和 3 号预约,总时长 = 1 + 3 = 4。

示例2:

输入: 2,7,9,3,1

输出: 12

解释: 选择 1 号预约、 3 号预约和 5 号预约,总时长 = 2 + 9 + 1 = 12。

示例3:

输入: 2,1,4,5,3,1,1,3

输出: 12

解释: 选择 1 号预约、 3 号预约、 5 号预约和 8 号预约,总时长 = 2 + 4 + 3 + 3 = 12。

2️⃣题目解析

dpi表示i位置为当前的最长按摩时间。根据题目要求,由于第i个位置我们可以选择也可以不选择,所以我们需要对dpi表的这两种状态进行细分:

第一种状态:选择i位置,用vector<int> f(n)来表示该状态。
第二种状态:不选择i位置,用vector<int> g(n)来表示该状态。

关于初始化的话,如下:

  • f[0] = nums[0](第一次预约选择即f[0]的值当然是第一次预约时间啦)
  • g[0] = 0(第一次预约不选择的话表示0位置的值就是0啦)

状态转移方程如下:

  • f[i] = g[i-1] + nums[i]
  • g[i] = (f[i-1] , g[i-1])

返回值:max(f[n-1],g[n-1])

3️⃣解题代码

cpp 复制代码
class Solution {
public:
    int massage(vector<int>& nums) {
        int n = nums.size();
        if(n == 0) return 0;
        // 创建dp表
        vector<int> f(n);
        vector<int> g(n);
 
        // 初始化
        f[0] = nums[0],g[0] = 0;

        // 填表
        for(int i = 1;i < n;i++)
        {
            f[i] = g[i-1] + nums[i];
            g[i] = max(f[i-1],g[i-1]);
        }

        // 返回值
        return max(f[n-1],g[n-1]);
    }
};

代码通过

相关推荐
hahaha601625 分钟前
数字图像时域滤波或者3D降噪算法FPGA实现
算法·计算机视觉·fpga开发
文丑颜不良啊27 分钟前
LeetCode1541~1560题目解析
java·leetcode
YSL07012431 分钟前
一文通关-----树和二叉树
数据结构·算法
青少儿编程课堂34 分钟前
蓝桥杯青少组图形化+信息素养+电子学会Scratch考级:校园口算闯关解析
c++·python·算法·bfs·信息学竞赛
computersciencer40 分钟前
应用贝叶斯公式:迟到了,那坐的是哪种交通工具呢?
算法·机器学习·概率论
若亦_43 分钟前
排序>>交换排序
java·数据结构·算法
dialect_9 小时前
KMP算法
开发语言·c++·算法
reikocao10 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz10 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·11 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造